﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim ColumnHeaders	As List
End Sub

Public Sub PopulateArchers(pDB As SQL, pTV As TableView)

	ColumnHeaders.Initialize
	ColumnHeaders.Add("Id")
	ColumnHeaders.Add("AA")
	ColumnHeaders.Add("Last Name")
	ColumnHeaders.Add("First Name")
	DBUtils.ExecuteTableView(pDB, "SELECT ROW_ID, AA_NUMBER, LAST_NAME, FIRST_NAME FROM ARCHER ORDER BY LAST_NAME, FIRST_NAME", Null, 0, pTV, ColumnHeaders)
	pTV.SetColumnVisible(0,False)

End Sub

Public Sub FillArcherDefaultClass(pDB As SQL, pList As List)

	DBUtils.ExecuteList(pDB, "SELECT ARCHER_CATEGORY FROM CLASS", Null, 0, pList)

End Sub

Public Sub FillArcherDefaultDivision(pDB As SQL, pList As List)

	DBUtils.ExecuteList(pDB, "SELECT BOW_TYPE FROM DIVISION", Null, 0, pList)

End Sub

Public Sub GetArcherRecord(pDB As SQL, pRowId As Int) As Map

	Dim m As Map

	m = DBUtils.ExecuteMap(pDB, "SELECT A.ROW_ID, A.LAST_NAME, A.FIRST_NAME, strftime('%d/%m/%Y', A.DATE_OF_BIRTH) AS 'DATE_OF_BIRTH', A.AA_NUMBER, A.RGB, A.CLUB, D.BOW_TYPE, C.ARCHER_CATEGORY, IFNULL(A.GENDER, '') AS 'GENDER' FROM ARCHER A LEFT JOIN DIVISION D ON A.DEFAULT_DIVISION_ROW_ID = D.ROW_ID LEFT JOIN CLASS C ON A.DEFAULT_CLASS_ROW_ID = C.ROW_ID WHERE A.ROW_ID = ?", Array As String(pRowId))
	Return m

End Sub

Public Sub UpdateArcher(pDB As SQL, pClean As Map, pDirty As Map)

	Dim values	As Map
	Dim filter	As Map
	Dim date	As String
	Dim ticks	As Long

	values.Initialize
	filter.Initialize
	If pClean.Get("aa_number") <> pDirty.Get("aa_number") Then
		values.Put("aa_number", pDirty.Get("aa_number"))
	End If
	If pClean.Get("last_name") <> pDirty.Get("last_name") Then
		values.Put("last_name", pDirty.Get("last_name"))
	End If
	If pClean.Get("first_name") <> pDirty.Get("first_name") Then
		values.Put("first_name", pDirty.Get("first_name"))
	End If
	If pClean.Get("rgb") <> pDirty.Get("rgb") Then
		values.Put("rgb", pDirty.Get("rgb"))
	End If
	If pClean.Get("club") <> pDirty.Get("club") Then
		values.Put("club", pDirty.Get("club"))
	End If
	If pClean.Get("first_name") <> pDirty.Get("first_name") Then
		values.Put("first_name", pDirty.Get("first_name"))
	End If
	If pClean.Get("date_of_birth") <> pDirty.Get("date_of_birth") Then
		ticks = DateTime.DateParse(pDirty.Get("date_of_birth"))
		DateTime.DateFormat = "yyyy-MM-dd"
		date = DateTime.date(ticks)
		values.Put("date_of_birth", date)
	End If
	If pClean.Get("gender") <> pDirty.Get("gender") Then
		values.Put("gender", pDirty.Get("gender"))
	End If
	If pClean.Get("bow_type") <> pDirty.Get("bow_type") Then
		If pDirty.Get("bow_type") = "" Then
			values.Put("default_division_row_id", Null)
		Else
			Dim row_id As String
			row_id = pDB.ExecQuerySingleResult2("Select ROW_ID FROM DIVISION WHERE BOW_TYPE = ?", Array As String(pDirty.Get("bow_type")))
			values.Put("default_division_row_id", row_id)
		End If
	End If
	If pClean.Get("archer_category") <> pDirty.Get("archer_category") Then
		If pDirty.Get("archer_category") = "" Then
			values.Put("default_class_row_id", Null)
		Else
			Dim row_id As String
			row_id = pDB.ExecQuerySingleResult2("Select ROW_ID FROM CLASS WHERE ARCHER_CATEGORY = ?", Array As String(pDirty.Get("archer_category")))
			values.Put("default_class_row_id", row_id)
		End If
	End If
	filter.Put("row_id", pDirty.Get("row_id"))
	DBUtils.UpdateRecord2(pDB, "ARCHER", values, filter)

End Sub