﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals


End Sub

Private Sub EscapeField(f As String) As String

	Return "[" & f & "]"

End Sub

Public Sub ExecuteTableView(pDB As SQL, pQuery As String, pArgs() As String, pLimit As Int, _
	pTableView As TableView, pColumnHeaders As List)

	Dim cur As ResultSet

	pTableView.Items.Clear
	If pArgs = Null Then 
		Dim pArgs(0) As String
	End If
	cur = pDB.ExecQuery2(pQuery,pArgs)
	pTableView.SetColumns(pColumnHeaders)
	Do While cur.NextRow
		Dim values(cur.ColumnCount) As String
		For col = 0 To cur.ColumnCount - 1
			values(col) = cur.GetString2(col)
		Next
		pTableView.Items.Add(values)
		If pLimit > 0 AND pTableView.Items.Size >= pLimit Then Exit
	Loop
	cur.Close

End Sub

Public Sub ExecuteList(pDB As SQL, pQuery As String, pStringArgs() As String, pLimit As Int, pList1 As List)

	pList1.Clear

	Dim Table As List

	Table = ExecuteMemoryTable(pDB, pQuery, pStringArgs, pLimit)
	If Table.Size = 0 Then Return
	Dim Cols() As String
	For i = 0 To Table.Size - 1
		Cols = Table.Get(i)
		pList1.Add(Cols(0))
	Next

End Sub

Public Sub ExecuteMemoryTable(pDB As SQL, pQuery As String, pStringArgs() As String, pLimit As Int) As List

	Dim cur As ResultSet

	If pStringArgs = Null Then 
		Dim pStringArgs(0) As String
	End If
	cur = pDB.ExecQuery2(pQuery, pStringArgs)
	Log("ExecuteMemoryTable: " & pQuery)

	Dim table As List

	table.Initialize
	Do While cur.NextRow
		Dim values(cur.ColumnCount) As String
		For col = 0 To cur.ColumnCount - 1
			values(col) = cur.GetString2(col)
		Next
		table.Add(values)
		If pLimit > 0 AND table.Size >= pLimit Then Exit
	Loop
	cur.Close
	Return table

End Sub

Public Sub ExecuteMap(pDB As SQL, pQuery As String, pStringArgs() As String) As Map

	Dim res As Map
	Dim cur As ResultSet

	If pStringArgs <> Null Then 
		cur = pDB.ExecQuery2(pQuery, pStringArgs)
	Else
		cur = pDB.ExecQuery(pQuery)
	End If
	Log("ExecuteMap: " & pQuery)
	If cur.NextRow = False Then
		Log("No records found.")
		Return res
	End If
	res.Initialize
	For i = 0 To cur.ColumnCount - 1
		res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
	Next
	cur.Close
	Return res

End Sub

'---------------------------------------------------------------------------
' Updates multiple columns in a record
' Columns map the keys are the column names
'---------------------------------------------------------------------------
Public Sub UpdateRecord2(pDB As SQL, pTable As String, pColumns As Map, pFilterEquals As Map)

	If pFilterEquals.Size = 0 Then
		Log("Update Record - No lookup value specified")
		Return
	End If
	If pColumns.Size = 0 Then
		Log("Update Record - No columns and value specified")
		Return
	End If
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("UPDATE ").Append(EscapeField(pTable)).Append(" SET ")
	Dim args As List
	args.Initialize
	For i=0 To pColumns.Size-1
		If i<>pColumns.Size-1 Then
			sb.Append(EscapeField(pColumns.GetKeyAt(i))).Append("=?,")
		Else
			sb.Append(EscapeField(pColumns.GetKeyAt(i))).Append("=?")
		End If
		args.Add(pColumns.GetValueAt(i))
	Next
    
	sb.Append(" WHERE ")
	For i = 0 To pFilterEquals.Size - 1
		If i > 0 Then 
			sb.Append(" AND ")
		End If
		sb.Append(EscapeField(pFilterEquals.GetKeyAt(i))).Append(" = ?")
		args.Add(pFilterEquals.GetValueAt(i))
	Next
	Log("UpdateRecord: " & sb.ToString)
	pDB.BeginTransaction
	Try
		pDB.ExecNonQuery2(sb.ToString, args)
		pDB.TransactionSuccessful
	Catch
		Log (LastException.Message)
		pDB.Rollback
	End Try
	
End Sub